org.apache.storm.hbase.bolt

## Class AbstractHBaseBolt

- java.lang.Object
- - org.apache.storm.topology.base.BaseComponent
  - - org.apache.storm.topology.base.BaseRichBolt
    - - org.apache.storm.hbase.bolt.AbstractHBaseBolt

- All Implemented Interfaces:
    Serializable, IBolt, IComponent, IRichBolt
  Direct Known Subclasses:
    HBaseBolt, HBaseLookupBolt

      public abstract class AbstractHBaseBolt
      extends BaseRichBolt

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected OutputCollector` | `collector`
    `protected String` | `configKey`
    `protected HBaseClient` | `hBaseClient`
    `protected HBaseMapper` | `mapper`
    `protected String` | `tableName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractHBaseBolt(String tableName, HBaseMapper mapper)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `cleanup()` Called when an IBolt is going to be shutdown.
    `void` | `prepare(Map<String,Object> topoConf, TopologyContext topologyContext, OutputCollector collector)` Called when a task for this component is initialized within a worker on the cluster.

    - ### Methods inherited from class org.apache.storm.topology.base.BaseComponent

      `getComponentConfiguration`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.storm.task.IBolt

      `execute`

    - ### Methods inherited from interface org.apache.storm.topology.IComponent

      `declareOutputFields, getComponentConfiguration`

- - ### Field Detail

    - #### collector

          protected transient OutputCollector collector

    - #### hBaseClient

          protected transient HBaseClient hBaseClient

    - #### tableName

          protected String tableName

    - #### mapper

          protected HBaseMapper mapper

    - #### configKey

          protected String configKey

  - ### Constructor Detail

    - #### AbstractHBaseBolt

          public AbstractHBaseBolt(String tableName,
                                   HBaseMapper mapper)

  - ### Method Detail

    - #### prepare

          public void prepare(Map<String,Object> topoConf,
                              TopologyContext topologyContext,
                              OutputCollector collector)

      Description copied from interface: `IBolt`

      Called when a task for this component is initialized within a worker on the cluster. It provides the bolt with the environment in which the bolt executes.

      This includes the:

      Parameters:
        `topoConf` - The Storm configuration for this bolt. This is the configuration provided to the topology merged in with cluster configuration on this machine.
        `topologyContext` - This object can be used to get information about this task’s place within the topology, including the task id and component id of this task, input and output information, etc.
        `collector` - The collector is used to emit tuples from this bolt. Tuples can be emitted at any time, including the prepare and cleanup methods. The collector is thread-safe and should be saved as an instance variable of this bolt object.

    - #### cleanup

          public void cleanup()

      Description copied from interface: `IBolt`

      Called when an IBolt is going to be shutdown. Storm will make a best-effort attempt to call this if the worker shutdown is orderly. The `Config.SUPERVISOR_WORKER_SHUTDOWN_SLEEP_SECS` setting controls how long orderly shutdown is allowed to take. There is no guarantee that cleanup will be called if shutdown is not orderly, or if the shutdown exceeds the time limit.

      The one context where cleanup is guaranteed to be called is when a topology is killed when running Storm in local mode.

      Specified by:
        `cleanup` in interface `IBolt`
      Overrides:
        `cleanup` in class `BaseRichBolt`

Copyright © 2021 The Apache Software Foundation. All rights reserved.